﻿using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

namespace Viziblr.ColourLovers
{
    public class Palette
    {
        public string ID { get; set; }
        public string Title { get; set; }
        public string UserName { get; set; }
        public string APIURL { get; set; }
        public int NumVotes { get; set; }
        public List<Swatch> Swatches { get; set; }

        public static Palette FromXmlElement(XElement theme_el)
        {
            if (theme_el == null)
            {
                throw new System.ArgumentNullException("theme_el");
            }

            var palette = new Palette();
            palette.ID = theme_el.Element("id").Value;
            palette.Title = theme_el.Element("title").Value;
            palette.UserName = theme_el.Element("userName").Value;
            palette.NumVotes = int.Parse(theme_el.Element("numVotes").Value);
            palette.APIURL= theme_el.Element("apiUrl").Value;

            palette.Swatches = theme_el.Descendants("colors")
                .Select(el => Swatch.FromXml(el))
                .ToList();
            return palette;
        }
    }
}