﻿namespace Viziblr.Drawing
{
    public struct LineSegment
    {
        private readonly Point _start;
        private readonly Point _end;

        public LineSegment(Point start, Point end)
        {
            this._start = start;
            this._end = end;
        }

        public LineSegment(Point[] points)
        {
            if (points == null)
            {
                throw new System.ArgumentNullException("points");
            }

            if (points.Length != 2)
            {
                throw new System.ArgumentOutOfRangeException("points", "Must have exactly 2 points");
            }

            this._start = points[0];
            this._end = points[1];
        }

        public Point Start
        {
            get { return _start; }
        }

        public Point End
        {
            get { return _end; }
        }

        public Point[] ToPoints()
        {
            var points = new[] { this._start, this._end };
            return points;
        }
    }
}