namespace Viziblr.SystemDrawing.Extensions
{
    public static class GraphicsExtensions
    {
        public static void Fill(this System.Drawing.Graphics g, System.Drawing.Brush brush)
        {
            var cb = g.VisibleClipBounds;
            g.FillRectangle(brush, cb);
        }

        public static void FillEllipse(this System.Drawing.Graphics g, System.Drawing.Rectangle rect, System.Drawing.Color centercolor, System.Drawing.Color edgecolor, float focus)
        {

            using (var pth = new System.Drawing.Drawing2D.GraphicsPath())
            {
                pth.AddEllipse(rect);
                var pgb = new System.Drawing.Drawing2D.PathGradientBrush(pth);
                pgb.CenterColor = centercolor;
                pgb.SurroundColors = new[] { edgecolor };
                pgb.FocusScales = new System.Drawing.PointF(focus, focus);

                g.FillEllipse(pgb, rect);
            }

        }

    }
}