﻿using System.Collections.Generic;

namespace Viziblr.Printing
{
    public class PaperSizesDB
    {
        public readonly PaperSize NA_Letter = new PaperSize("North American Letter", 8.5, 11, 216, 279);
        public readonly PaperSize NA_Legal = new PaperSize("North American Legal", 8.5, 14, 216, 356);
        public readonly PaperSize NA_JuniorLegal = new PaperSize("North American Junior Legal", 8.0, 5.0, 203, 127);
        public readonly PaperSize NA_Ledger = new PaperSize("North American Ledger", 17, 11, 432, 279);
        public readonly PaperSize NA_Tabloid = new PaperSize("North American Tabloid", 11, 17, 279, 432);

        public readonly PaperSize ANSI_A = new PaperSize("ANSI A", 8.5, 11, 216, 279);
        public readonly PaperSize ANSI_B_Ledger = new PaperSize("ANSI B Ledger", 17, 11, 432, 2799);
        public readonly PaperSize ANSI_B_Tabloid = new PaperSize("ANSI B Tabloid", 11, 17, 279, 432);
        public readonly PaperSize ANSI_C = new PaperSize("ANSI C", 17, 22, 432, 559);
        public readonly PaperSize ANSI_D = new PaperSize("ANSI D", 22, 34, 559, 864);
        public readonly PaperSize ANSI_E = new PaperSize("ANSI E", 34, 44, 864, 1118);

        public readonly PaperSize ISO_A0 = new PaperSize("ISO A0", 33.1, 46.8, 841, 1189);
        public readonly PaperSize ISO_A1 = new PaperSize("ISO A1", 23.4, 33.1, 594, 841);
        public readonly PaperSize ISO_A2 = new PaperSize("ISO A2", 16.5, 23.4, 420, 594);
        public readonly PaperSize ISO_A3 = new PaperSize("ISO A3", 11.7, 16.5, 297, 420);
        public readonly PaperSize ISO_A4 = new PaperSize("ISO A4", 8.3, 11.7, 210, 297);
        public readonly PaperSize ISO_A5 = new PaperSize("ISO A5", 5.8, 8.3, 148, 210);
        public readonly PaperSize ISO_A6 = new PaperSize("ISO A6", 4.1, 5.8, 105, 148);
        public readonly PaperSize ISO_A7 = new PaperSize("ISO A7", 2.9, 4.1, 74, 105);
        public readonly PaperSize ISO_A8 = new PaperSize("ISO A8", 2.0, 2.9, 52, 74);
        public readonly PaperSize ISO_A9 = new PaperSize("ISO A9", 1.5, 2.0, 37, 52);
        public readonly PaperSize ISO_A10 = new PaperSize("ISO A10", 1.0, 1.5, 26, 37);

        public readonly PaperSize ISO_B0 = new PaperSize("ISO B0", 39.4, 55.7, 1000, 1414);
        public readonly PaperSize ISO_B1 = new PaperSize("ISO B1", 27.8, 39.4, 707, 1000);
        public readonly PaperSize ISO_B2 = new PaperSize("ISO B2", 19.7, 27.8, 500, 707);
        public readonly PaperSize ISO_B3 = new PaperSize("ISO B3", 13.9, 19.7, 353, 500);
        public readonly PaperSize ISO_B4 = new PaperSize("ISO B4", 9.8, 13.9, 250, 353);
        public readonly PaperSize ISO_B5 = new PaperSize("ISO B5", 6.9, 9.8, 176, 250);
        public readonly PaperSize ISO_B6 = new PaperSize("ISO B6", 4.9, 6.9, 125, 176);
        public readonly PaperSize ISO_B7 = new PaperSize("ISO B7", 3.5, 4.9, 88, 125);
        public readonly PaperSize ISO_B8 = new PaperSize("ISO B8", 2.4, 3.5, 62, 88);
        public readonly PaperSize ISO_B9 = new PaperSize("ISO B9", 1.7, 2.4, 44, 62);
        public readonly PaperSize ISO_B10 = new PaperSize("ISO B10", 1.2, 1.7, 31, 44);

        public readonly PaperSize ISO_C0 = new PaperSize("ISO C0", 36.1, 51.1, 917, 1297);
        public readonly PaperSize ISO_C1 = new PaperSize("ISO C1", 25.5, 36.1, 648, 917);
        public readonly PaperSize ISO_C2 = new PaperSize("ISO C2", 18.0, 25.5, 458, 648);
        public readonly PaperSize ISO_C3 = new PaperSize("ISO C3", 12.8, 18.0, 324, 458);
        public readonly PaperSize ISO_C4 = new PaperSize("ISO C4", 9.0, 12.8, 229, 324);
        public readonly PaperSize ISO_C5 = new PaperSize("ISO C5", 6.4, 9.0, 162, 229);
        public readonly PaperSize ISO_C6 = new PaperSize("ISO C6", 4.5, 6.4, 114, 162);
        public readonly PaperSize ISO_C7 = new PaperSize("ISO C7", 3.2, 4.5, 81, 114);
        public readonly PaperSize ISO_C8 = new PaperSize("ISO C8", 2.2, 3.2, 57, 81);
        public readonly PaperSize ISO_C9 = new PaperSize("ISO C9", 1.6, 2.2, 40, 57);
        public readonly PaperSize ISO_C10 = new PaperSize("ISO C10", 1.1, 1.6, 28, 40);

        private List<PaperSize> m_papersizes;

        public PaperSizesDB()
        {
            this.m_papersizes = new List<PaperSize>();
            this.m_papersizes.Add( this.ANSI_A );
            this.m_papersizes.Add( this.ANSI_B_Ledger );
            this.m_papersizes.Add( this.ANSI_B_Tabloid );
            this.m_papersizes.Add( this.ANSI_C );
            this.m_papersizes.Add( this.ANSI_D );
            this.m_papersizes.Add( this.ANSI_E );
            this.m_papersizes.Add( this.ISO_A0 );
            this.m_papersizes.Add( this.ISO_A1 );
            this.m_papersizes.Add( this.ISO_A10 );
            this.m_papersizes.Add( this.ISO_A2 );
            this.m_papersizes.Add( this.ISO_A3 );
            this.m_papersizes.Add( this.ISO_A4 );
            this.m_papersizes.Add( this.ISO_A5 );
            this.m_papersizes.Add( this.ISO_A6 );
            this.m_papersizes.Add( this.ISO_A7 );
            this.m_papersizes.Add( this.ISO_A8 );
            this.m_papersizes.Add( this.ISO_A9 );
            this.m_papersizes.Add( this.ISO_B0 );
            this.m_papersizes.Add( this.ISO_B1 );
            this.m_papersizes.Add( this.ISO_B10 );
            this.m_papersizes.Add( this.ISO_B2 );
            this.m_papersizes.Add( this.ISO_B3 );
            this.m_papersizes.Add( this.ISO_B4 );
            this.m_papersizes.Add( this.ISO_B5 );
            this.m_papersizes.Add( this.ISO_B6 );
            this.m_papersizes.Add( this.ISO_B7 );
            this.m_papersizes.Add( this.ISO_B8 );
            this.m_papersizes.Add( this.ISO_B9 );
            this.m_papersizes.Add( this.ISO_C0 );
            this.m_papersizes.Add( this.ISO_C1 );
            this.m_papersizes.Add( this.ISO_C10 );
            this.m_papersizes.Add( this.ISO_C2 );
            this.m_papersizes.Add( this.ISO_C3 );
            this.m_papersizes.Add( this.ISO_C4 );
            this.m_papersizes.Add( this.ISO_C5 );
            this.m_papersizes.Add( this.ISO_C6 );
            this.m_papersizes.Add( this.ISO_C7 );
            this.m_papersizes.Add( this.ISO_C8 );
            this.m_papersizes.Add( this.ISO_C9 );
            this.m_papersizes.Add( this.NA_JuniorLegal );
            this.m_papersizes.Add( this.NA_Ledger );
            this.m_papersizes.Add( this.NA_Legal );
            this.m_papersizes.Add( this.NA_Letter );
            this.m_papersizes.Add( this.NA_Tabloid );
        }

        public IList<PaperSize> PaperSizes
        {
            get
            {
                return this.m_papersizes;
            }
        }
    }
}